/*	===========================================================================
	AADebug Ver. 0.11
	Copyright (C) 2007 Fourteenforty Research Institute, Inc.
	Coded by Yuji Ukai <yukai@fourteenforty.jp>
	===========================================================================
*/

#include	<windows.h>
#include	<stdio.h>
#include	<Iphlpapi.h>
#include	<IPExport.h>
#include	"drvload.h"

VOID ShowLastError(VOID)
{
	DWORD	err;
    LPVOID lpMsgBuf;

	err=GetLastError();
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        err,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0,
        NULL);
    printf("ShowLastError > (code=%d/0x%x) %s\n",err,err,(char*)lpMsgBuf);
    LocalFree(lpMsgBuf);
}


int LoadDriver(char *fname)
{
	void ShowLastError(void);
    SC_HANDLE		hSCManager;
    SC_HANDLE		hService;
    SERVICE_STATUS	serviceStatus;
    BOOL			ret;
	char			filepath[512],filename[512];

	printf("LoadDriver : LoadDriver '%s' \n",fname);

	memset(filepath,0,sizeof(filepath));
	GetCurrentDirectory(sizeof(filepath)-1,filepath);
	filepath[sizeof(filepath)-1]='\0';
	if (filepath[strlen(filepath)-1]=='\\')
		filepath[strlen(filepath)-1]='\0';
	memset(filename,0,sizeof(filename));
	_snprintf(filename,sizeof(filename)-1,"%s\\%s",filepath,fname);

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager){
		printf("LoadDriver : OpenSCManager error\n");
		ShowLastError();
		return -1;
	}

	hService = OpenService( hSCManager,
							fname,
							SERVICE_ALL_ACCESS);
	if(hService){
		ret = ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
		ret = DeleteService(hService);
		CloseServiceHandle(hService);
	}

	hService = CreateService(hSCManager,
		fname,
		fname,
		SERVICE_ALL_ACCESS,
		SERVICE_KERNEL_DRIVER,
		SERVICE_DEMAND_START,
		SERVICE_ERROR_NORMAL,
		filename,
		NULL,NULL,NULL,NULL,NULL);

	ret = -2;
    if(hService) {
		ret = StartService(hService, 0, NULL);
		if (!ret){
			printf("LoadDriver : StartService error ret=%d\n",ret);
			ShowLastError();
			ret = -2;
		}
		if (!CloseServiceHandle(hService)){
			printf("LoadDriver : CloseServiceHandle1 error\n");
			ShowLastError();
			ret = -3;
		}
	}else{
		printf("LoadDriver : CreateService error\n");
		ShowLastError();
		ret = -4;
	}

	if (!CloseServiceHandle(hSCManager)){
		printf("LoadDriver : CloseServiceHandle2 error\n");
		ShowLastError();
		ret = -5;
	}

	if (ret>=0)
		printf("LoadDriver : Driver loaded.\n");

	return ret;
}

int UnloadDriver(char *drivername)
{
	SC_HANDLE	hSCManager;
	SC_HANDLE	hService;
	SERVICE_STATUS  serviceStatus;
	BOOL	ret;

    hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager){
		printf("UnloadDriver : OpenSCManager error\n");
		ShowLastError();
		return -1;
	}

    hService = OpenService(hSCManager, drivername, SERVICE_ALL_ACCESS);
	ret = -2;
	if(hService) {
	    ret = ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
		if(ret){
	        ret = DeleteService(hService);
			if (!ret){
				printf("UnloadDriver : DeleteService error\n");
				ShowLastError();
				ret = -5;
			}
		}
	    if (!CloseServiceHandle(hService)){
			printf("UnloadDriver : CloseServiceHandle2 error\n");
			ShowLastError();
			ret = -4;
		}
	}else{
		printf("UnloadDriver : OpenService error\n");
		ShowLastError();
		ret = -3;
	}
    if (!CloseServiceHandle(hSCManager)){
		printf("UnloadDriver : CloseServiceHandle2 error\n");
		ShowLastError();
		ret = -4;
	}
	if (ret>=0)
		printf("UnloadDriver : Driver unloaded.\n");

    return ret;
}
